--[[
	WO EZ Calendar Guild invits
	Version : v0.1
	Date    : 2020-01-06T04:56:12Z
	Author  : woOtzee

                    __    ,- Made with ❤ by woOtzee.com
                   /✷_)      
           _.---._/ /
         /         /
      _/         |/
     /__.-|_|--|_| 
]]

local WOez_cframe = CreateFrame("Frame")
local WOez_MDOS = "Interface\\AddOns\\WO_ezcalinvit\\medias\\"
local WOez_Font = WOez_MDOS.."font_txt.ttf"
local WOez_open = false
local WOez_2invit = {}
local WOez_2remov = {}
local WOez_2procs = 0
local WOez_progress = false
local WOez_LastUpdate = 0
local WOez_canEdit = false
local WOez_colorGrn = "00ffb7"
local WOez_colorRed = "ff4000"

-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------
    
function WOF_Frame(name,type,where,opt,z,x,y,yy,zz,w,h)
    local obj = name
    local stuff = _G[obj] or CreateFrame(type,obj,where,opt)
    if z then stuff:SetPoint(z,x,y,yy,zz) end
    if w and h then stuff:SetSize(w,h) end
    return stuff
end
function WOF_FadeF(obj,where,allpoint,f)
    local obj = where:CreateTexture(nil, "BACKGROUND")             
    if allpoint then obj:SetAllPoints(true) end
    obj:SetColorTexture(0,0,0,f)
    return obj
end
function WOF_IconF(name,where,ico,z,x,y,w,h)
    local obj = name
    local stuff = _G[obj] or where:CreateTexture(obj,"HIGH") 
    stuff:SetPoint(z,x,y) stuff:SetSize(w,h) stuff:SetTexture(ico) 
    return stuff
end
function WOF_FontS(name,where,z,x,y,w,h,font,siz,justifyH)
    local obj = name
    local stuff = _G[obj] or where:CreateFontString(obj)   
    stuff:SetFont(font,siz) 
    stuff:SetPoint(z,x,y) 
    stuff:SetSize(w,h) 
    stuff:SetJustifyH(justifyH) 
    stuff:SetJustifyV("TOP") 
    return stuff
end

-- -----------------------------------------------------------------------------

function WOez_table_len(T)
    local count = 0
    for _ in pairs(T) do count = count + 1 end
    return count
end
function WOez_table_isin(T,val)
    local isin = false
    for _,v in pairs(T) do 
        if v == val then 
            isin = true 
            break 
        end
    end
    return isin
end

function WOez_SendNotif(color,msg)
    DEFAULT_CHAT_FRAME:AddMessage("|cff"..color.."/!\\ INVIT:|r "..msg.."|r")
end

-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------

WOez_cframe:RegisterEvent("CALENDAR_OPEN_EVENT")
WOez_cframe:RegisterEvent("CALENDAR_UPDATE_ERROR")
WOez_cframe:RegisterEvent("CALENDAR_UPDATE_INVITE_LIST")
WOez_cframe:RegisterEvent("CALENDAR_CLOSE_EVENT")
WOez_cframe:RegisterEvent("GUILD_ROSTER_UPDATE")
WOez_cframe:RegisterEvent("CALENDAR_ACTION_PENDING")

-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------

WOez_cframe:SetScript("OnUpdate",function(self,elapsed)
    WOez_LastUpdate = WOez_LastUpdate + elapsed
    if WOez_LastUpdate > 2 then
        if not WOez_progress then
            local e_info = C_Calendar.GetEventInfo()
            if e_info then
                local NumInv = C_Calendar.GetNumInvites()
                
                if WOez_2procs > 0 then
                    WOez_InProgress:Show() Fade4:Show()
                    WOez_InProgress:SetText("UPDATING...")
                else
                    WOez_InProgress:Hide() Fade4:Hide()
                    WOez_InProgress:SetText("UPDATING...")
                end
                
                if WOez_2invit ~= nil and WOez_table_len(WOez_2invit) > 0 then
                    if e_info.isLocked then 
                        wipe(WOez_2invit)
                        WOez_SendNotif(WOez_colorRed,"|cff"..WOez_colorRed.."[ "..e_info.title.." ] locked...")
                        WOez_roster() 
                    else
                        local invite = table.remove(WOez_2invit,1)
                        WOez_InProgress:SetText("UPDATING: "..WOez_2procs.." Left...   |cffffbb00ADDING "..invite)
                        local AlreadyInv = false
                        if NumInv < 100 then
                            for i = 1, NumInv do
                                local inviteData = C_Calendar.EventGetInvite(i)
                                if invite == inviteData.name then 
                                    AlreadyInv = true 
                                    WOez_SendNotif(WOez_colorRed,"|cff"..WOez_colorRed..invite.." is already invited...")
                                    break
                                end
                            end
                            if not AlreadyInv then 
                                C_Calendar.EventInvite(invite) 
                            end
                        end
                    end
                elseif WOez_2remov ~= nil and WOez_table_len(WOez_2remov) > 0 then
                    local remove = table.remove(WOez_2remov,1)
                    WOez_InProgress:SetText("UPDATING: "..WOez_2procs.." Left...   |cffffbb00REMOVING "..remove)
                    for i = 1, NumInv do
                        local inviteData = C_Calendar.EventGetInvite(i)
                        if remove == inviteData.name then 
                            C_Calendar.EventRemoveInvite(i) 
                            break
                        end
                    end
                end
                WOez_2procs = WOez_table_len(WOez_2invit) + WOez_table_len(WOez_2remov)
                WOez_GetEventInfo()
            else
                wipe(WOez_2invit)
                wipe(WOez_2remov)
            end
        end        

        WOez_LastUpdate = 0;
    end
end)

WOez_cframe:SetScript("OnEvent",function(self,event,...)
    -- -------------------------------------------------------------------------
    if event == "CALENDAR_OPEN_EVENT" then
        local eventType = ...
        if eventType == "PLAYER" or eventType == "GUILD_EVENT" then 
            WOez_open = true    WOez_roster() 
        else 
            WOez_open = false   WOez_cframe:Hide()
        end
    -- -------------------------------------------------------------------------
    elseif event == "CALENDAR_UPDATE_ERROR" then  
        WOez_progress = false 
        WOez_roster() 
    -- -------------------------------------------------------------------------
    elseif event == "CALENDAR_UPDATE_INVITE_LIST" then
        if WOez_progress then
            WOez_progress = false 
            WOez_open = true        
            WOez_roster() 
        end
    -- -------------------------------------------------------------------------
    elseif event == "CALENDAR_CLOSE_EVENT" then
        WOez_open = false       WOez_cframe:Hide()
    -- -------------------------------------------------------------------------
    elseif event == "GUILD_ROSTER_UPDATE" then
        local arg = ... 
        if arg == true then     WOez_roster() end
    -- -------------------------------------------------------------------------
    elseif event == "CALENDAR_ACTION_PENDING" then
        local arg = ... 
        if arg == false and WOez_open then WOez_roster_icon() end
    -- -------------------------------------------------------------------------
    end
    return 
end)

function WOez_2invit_Handler(who) tinsert(WOez_2invit,who) WOez_2procs = WOez_2procs+1 WOez_InProgress:SetText("UPDATING: "..WOez_2procs.." Left...") WOez_InProgress:Show() Fade4:Show() end
function WOez_2remov_Handler(who) tinsert(WOez_2remov,who) WOez_2procs = WOez_2procs+1 WOez_InProgress:SetText("UPDATING: "..WOez_2procs.." Left...") WOez_InProgress:Show() Fade4:Show() end

-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------

function WOez_GetEventInfo() 
    local attendues = {}
    local Invites, Comming, NoReply, NotCmmg, WatCmmg, nbTNK, nbHLS, nbMLE, nbRNG = 0,0,0,0,0,0,0,0,0
    local NumInv = C_Calendar.GetNumInvites()
    for i = 1, NumInv do
		local inviteData = C_Calendar.EventGetInvite(i)
        attendues[inviteData.name] = {index=i,inviteStatus=inviteData.inviteStatus}
        Invites = Invites+1
            if inviteData.inviteStatus==1 then NoReply=NoReply+1 -- CALENDAR_INVITESTATUS_INVITED
        elseif inviteData.inviteStatus==2 then Comming=Comming+1 -- CALENDAR_INVITESTATUS_ACCEPTED
        elseif inviteData.inviteStatus==3 then NotCmmg=NotCmmg+1 -- CALENDAR_INVITESTATUS_DECLINED
        elseif inviteData.inviteStatus==4 then Comming=Comming+1 -- CALENDAR_INVITESTATUS_CONFIRMED
        elseif inviteData.inviteStatus==5 then NotCmmg=NotCmmg+1 -- CALENDAR_INVITESTATUS_OUT
        elseif inviteData.inviteStatus==6 then WatCmmg=WatCmmg+1 -- CALENDAR_INVITESTATUS_STANDBY
        elseif inviteData.inviteStatus==7 then Comming=Comming+1 -- CALENDAR_INVITESTATUS_SIGNEDUP
        elseif inviteData.inviteStatus==8 then NoReply=NoReply+1 -- CALENDAR_INVITESTATUS_NOT_SIGNEDUP
        elseif inviteData.inviteStatus==9 then WatCmmg=WatCmmg+1 -- CALENDAR_INVITESTATUS_TENTATIVE
        end
    end
    nbInvit:SetText(format('|cffffffff %s INVITS :',Invites) )
    nbCommg:SetText(format('|cffffbb00 %s',Comming) )
    nbNRply:SetText(format('|cffb8b8b8 %s ( +%s )',NoReply,WatCmmg)  )
    nbNCmmg:SetText(format('|cffe60000 %s',NotCmmg) )
    return attendues
end

-- -----------------------------------------------------------------------------

function WOez_GetIcon(ico) 
    local icon = '.tga'
        if ico==0 then icon =   "onway"..icon  elseif ico==1 then icon = "nbNRply"..icon
    elseif ico==2 then icon = "nbCommg"..icon  elseif ico==3 then icon = "nbNCmmg"..icon
    elseif ico==4 then icon = "nbCommg"..icon  elseif ico==5 then icon = "nbNCmmg"..icon
    elseif ico==6 then icon = "nbNRply"..icon  elseif ico==7 then icon = "nbCommg"..icon
    elseif ico==8 then icon = "nbNRply"..icon  elseif ico==9 then icon = "nbNRply"..icon end    
    return WOez_MDOS..icon
end

function WOez_roster_icon()
    local attendues = WOez_GetEventInfo()
    local allWOez_child = { WOez_child:GetChildren() };
    for _, WOez_children in ipairs(allWOez_child) do 
        if WOez_children:GetObjectType() == "CheckButton" then 
            local name_icone = WOez_children:GetName()
            local icone = _G[name_icone.."_ico"]
            local invit = _G[name_icone.."a"]
            if invit then
                local nname = invit:GetText()
                local atten = attendues[nname]
                if icone then
                        if WOez_table_isin(WOez_2invit,nname) then
                        icone:SetTexture(WOez_GetIcon(0))
                    elseif WOez_table_isin(WOez_2remov,nname) then
                        icone:SetTexture(WOez_GetIcon(0))
                    elseif atten then
                        icone:SetTexture(WOez_GetIcon(atten.inviteStatus)) 
                    else
                        icone:SetTexture(nil) 
                    end
                end
            end
        end
    end
end            

function WOez_disabButton(onoff)
    local allWOez_child = { WOez_child:GetChildren() };
    for _, WOez_children in ipairs(allWOez_child) do 
        if WOez_children:GetObjectType() == "CheckButton" then 
            local name_icone = WOez_children:GetName()
            local invit = _G[name_icone.."a"]
            if invit then
                local nname = invit:GetText()
                if nname == UnitName("player") then WOez_children:SetEnabled(false) 
                else WOez_children:SetEnabled(onoff) end
            end
        end
    end
end

-- -----------------------------------------------------------------------------

function WOez_roster()
    local e_info = C_Calendar.GetEventInfo()
    if e_info and WOez_open and _G.CalendarFrame and _G.CalendarFrame:IsShown() and (e_info.calendarType == "PLAYER" or e_info.calendarType == "GUILD_EVENT") then

        if C_Calendar.EventCanEdit() then WOez_canEdit = true else WOez_canEdit = false end

        local attendues = WOez_GetEventInfo()
        if not ElvUI then 
            if WOez_canEdit then WOez_cframe:SetSize(136,365) else WOez_cframe:SetSize(136,314) end
            WOez_cframe:SetPoint("TOPLEFT",_G.CalendarFrame,"TOPRIGHT",220,-18)
        else 
            if WOez_canEdit then WOez_cframe:SetSize(136,332) else WOez_cframe:SetSize(136,286) end
            WOez_cframe:SetPoint("TOPLEFT",_G.CalendarFrame,"TOPRIGHT",200,-13.5)
        end

        GuildRoster() 
        local numGuildMembers, numOnline, numOnlineAndMobile = GetNumGuildMembers()

        local allWOez_child = { WOez_child:GetChildren() };
        for _, WOez_children in ipairs(allWOez_child) do WOez_children:Hide() end

        local RosterGuild = {}
        for z=1,numGuildMembers do
            local name, _, rankIndex, level, _, _, note, _, _, _, classFileName,  _, _, _ = GetGuildRosterInfo(z);
            local rang = rankIndex+1 if rankIndex == 0 then rang = 2 end
            if RosterGuild[rang] == nil then RosterGuild[rang] = {} end 
            RosterGuild[rang][z] = {Nname=Ambiguate(name,"guild"),lvl=level,note=note,classcolor=RAID_CLASS_COLORS[classFileName]}
        end

        local hei = 0
        for i=2,10 do
            local Nname = GuildControlGetRankName(i)
            if RosterGuild[i] ~= nil then 

                local titl = WOF_Frame("WOez_childt_"..i,"Frame",WOez_child,nil,"TOPLEFT",-10,"-"..hei+5,nil,nil,200,16) titl:Show()
                local tixt = WOF_FontS("WOez_childx_"..i,titl,"TOPLEFT",0,0,200,16,WOez_MDOS.."font_title.ttf",13,"LEFT")  
                tixt:SetText("____ "..string.upper(Nname).." _____________________________________") tixt:SetTextColor(1,1,1,1) 
                
                hei = hei+20
                for k,c in pairs(RosterGuild[i]) do
                    local color = c.classcolor  
                    if c.lvl < UnitLevel("player") then alpha = .3 else alpha = 1 end

                    local bttn = WOF_Frame("WOez_childs_"..k,"CheckButton",WOez_child,"ChatConfigCheckButtonTemplate","TOPLEFT",5,"-"..hei-1,nil,nil,9,9.5)
                    local icon = WOF_IconF("WOez_childs_"..k.."_ico",bttn,nil,"TOPLEFT", 49,-1,7,7) 
                    local attn = attendues[c.Nname]
                    if attn then 
                        bttn:SetChecked(true) 
                        icon:SetTexture(WOez_GetIcon(attn.inviteStatus)) 
                    else 
                        bttn:SetChecked(false)  
                        icon:SetTexture(nil) 
                    end
                    -- 
                    if WOez_canEdit and e_info.calendarType == "PLAYER" and c.Nname ~= UnitName("player") then
                        WOez_disabButton(true)
                        bttn:SetScript("OnClick", function(self, button)
                            isChecked = self:GetChecked()
                            if isChecked then 
                                color = c.classcolor  escapeColor = string.format("|cff%02x%02x%02x", color.r*255, color.g*255, color.b*255)
                                WOez_SendNotif(WOez_colorGrn,"[ "..e_info.title.." ] +"..escapeColor..c.Nname)
                                icon:SetTexture(WOez_GetIcon(0))  WOez_2invit_Handler(c.Nname)
                            else 
                                color = c.classcolor  escapeColor = string.format("|cff%02x%02x%02x", color.r*255, color.g*255, color.b*255)
                                WOez_SendNotif(WOez_colorRed,"[ "..e_info.title.." ] -"..escapeColor..c.Nname)
                                icon:SetTexture(WOez_GetIcon(0))  WOez_2remov_Handler(c.Nname)
                            end
                        end)    
                    else
                        WOez_disabButton(false)
                    end
                    
                    local text = WOF_FontS("WOez_childs_"..k.."a",bttn,"TOPLEFT",10,-1,40,8,WOez_Font,7,"LEFT")  text:SetText(c.Nname) text:SetTextColor(color.r, color.g, color.b,alpha) 
                    local ilvl = WOF_FontS("WOez_childs_"..k.."b",bttn,"TOPLEFT",47,-1,20,8,WOez_Font,7,"RIGHT") ilvl:SetText(c.lvl)   ilvl:SetTextColor(1,1,1,alpha)  
                    local note = WOF_FontS("WOez_childs_"..k.."c",bttn,"TOPLEFT",70,-1,48,8,WOez_Font,7,"LEFT")  note:SetText(c.note)  note:SetTextColor(.4,.4,.4,alpha)       

                    bttn:Show()
                    hei = hei+8
                end 
            end 
        end
        if hei < 100 then hei = 101 end
        WOez_child:SetSize(130, hei+4) 
        WOez_ScrollBar:SetMinMaxValues(1, hei-100)
        WOez_cframe:Show() 
    end
end

-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------

    WOez_cframe = WOF_Frame("WOez_cframe","Frame",nil,nil,"TOPLEFT",0,0,nil,nil,136,280)
    WOez_cframe:SetFrameStrata("MEDIUM") 
    if not ElvUI then WOez_cframe:SetBackdrop({ edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 8 }) end

    local WOez_InProgress = WOF_FontS("WOez_InProgress",WOez_cframe,"BOTTOMLEFT",10,-37,136,30,WOez_Font,7,"LEFT") WOez_InProgress:SetText("UPDATING...")  WOez_InProgress:Hide()

-- -----------------------------------------------------------------------------

    WOez_Infos = WOF_Frame("WOez_Infos","Frame",WOez_cframe,nil,"TOPLEFT",WOez_cframe,"TOPLEFT",4,-4,128,32)

    nbInvit = WOF_FontS("WOez_nbInvit",WOez_Infos,"TOPLEFT",  6,-4,70,8,WOez_Font,7,"LEFT") nbInvit:SetText('|cffffffff?? INVITS :') 
    nbCommg = WOF_FontS("WOez_nbCommg",WOez_Infos,"TOPLEFT", 52,-4,30,8,WOez_Font,7,"LEFT") nbCommg:SetText('|cffffbb00??') 
    nbNRply = WOF_FontS("WOez_nbNRply",WOez_Infos,"TOPLEFT", 73,-4,50,8,WOez_Font,7,"LEFT") nbNRply:SetText('|cffb8b8b8??') 
    nbNCmmg = WOF_FontS("WOez_nbNCmmg",WOez_Infos,"TOPLEFT",115,-4,30,8,WOez_Font,7,"LEFT") nbNCmmg:SetText('|cffe60000??') 
      
    icCommg = WOF_IconF("WOez_icCommg",WOez_Infos,WOez_MDOS.."nbCommg.tga","TOPLEFT", 42,-3.25,8,8) 
    icNRply = WOF_IconF("WOez_icNRply",WOez_Infos,WOez_MDOS.."nbNRply.tga","TOPLEFT", 65,-3   ,9,9) 
    icNCmmg = WOF_IconF("WOez_icNCmmg",WOez_Infos,WOez_MDOS.."nbNCmmg.tga","TOPLEFT",105,-3   ,9,9) 

-- -----------------------------------------------------------------------------

    WOez_ScrollFrame = WOF_Frame("WOez_SF","ScrollFrame",WOez_cframe,nil,"TOPLEFT", WOez_cframe, "TOPLEFT",4,-24,nil,nil)
    WOez_ScrollFrame:SetPoint("BOTTOMRIGHT", WOez_cframe, "BOTTOMRIGHT",-4,4)
    WOez_cframe.ScrollFrame = WOez_ScrollFrame

    WOez_ScrollBar = WOF_Frame("WOez_SB","Slider",WOez_cframe.ScrollFrame,"UIPanelScrollBarTemplate","TOPLEFT", WOez_cframe,"TOPRIGHT",4,-10,nil,nil)
    WOez_ScrollBar:SetPoint("BOTTOMLEFT", WOez_cframe, "BOTTOMRIGHT", 4, 10)
    WOez_ScrollBar:SetMinMaxValues(1, 200) WOez_ScrollBar:SetValueStep(10) WOez_ScrollBar.scrollStep = 10 WOez_ScrollBar:SetValue(0) 
    WOez_ScrollBar:SetScript("OnValueChanged",function (self, value) self:GetParent():SetVerticalScroll(value) end)

    WOez_child = WOF_Frame("WOez_Chil","Frame",WOez_ScrollFrame,nil,nil,nil,nil,0,0,nil,nil)
    WOez_cframe.ScrollFrame:SetScrollChild(WOez_child)
    WOez_cframe.ScrollFrame:SetScript("OnMouseWheel", function (self, value) value = value*-1 val = WOez_ScrollBar:GetValue()+value*10 WOez_ScrollBar:SetValue(val) end)
    WOez_ScrollBar:SetScript(         "OnMouseWheel", function (self, value) value = value*-1 val = WOez_ScrollBar:GetValue()+value*10 WOez_ScrollBar:SetValue(val) end)

-- -----------------------------------------------------------------------------

    Fade1 = WOF_FadeF(WOez_cframe.textur1,WOez_cframe,true,.4)
    Fade2 = WOF_FadeF(WOez_cframe.textur2,WOez_cframe.ScrollFrame,true,.6)    
    Fade3 = WOF_FadeF(WOez_cframe.textur3,WOez_Infos ,false,.6)  Fade3:SetSize(128,16)  Fade3:SetPoint("TOPLEFT",0,0 ) 
    Fade4 = WOF_FadeF(WOez_cframe.textur4,WOez_cframe,false,.8)  Fade4:SetSize(136,16)  Fade4:SetPoint("BOTTOMLEFT",0,-18 ) Fade4:Hide()

-- -----------------------------------------------------------------------------

    WOez_SB:SetWidth(10)      WOez_SBThumbTexture:SetWidth(10)     WOez_SBThumbTexture:SetHeight(10)
                          WOez_SBScrollDownButton:SetWidth(10) WOez_SBScrollDownButton:SetHeight(10)
                            WOez_SBScrollUpButton:SetWidth(10)   WOez_SBScrollUpButton:SetHeight(10)

-- -----------------------------------------------------------------------------

    WOez_cframe:Hide()
